
/**
 * FichaAluno  uma classe que permite criar Fichas de Informao
 * sobre Alunos, contendo o seu nmero, nome, mdia e uma lista
 * contendo os nomes das disciplinas a que est inscrito.
 * 
 * @author F. Mrio Martins
 * @version 03/04/2005
 */
import java.util.*;
public class FichaAluno {

	// variveis de instncia
	
	private String numero;
	private String nome;
	private double media;            // mdia actual
	private ArrayList<String> discp; // nomes das disciplinas 
	

	/** Construtores */	
	public FichaAluno(FichaAluno fa) {		
		numero = fa.getNumero(); nome = fa.getNome(); media = fa.getMedia();
		discp = new ArrayList<String>(fa.getDiscp());		
	}
	
    public FichaAluno(String cod, String nom, double classif, 
                      ArrayList<String> ldiscp) {		
		numero = cod; nome = nom; media = classif;
		discp = new ArrayList<String>(ldiscp);
	}
	
   // Mtodos de instncia   
   /** Devolve o Nmero do aluno*/   
   public String getNumero(){ return numero;}
   
   /** Devolve o Nome do aluno */  
   public String getNome(){ return nome;}
   
    /** Devolve a mdia actual do aluno */  
   public double getMedia(){ return media;}
   
   /**
    * Devolve o ArrayList<String> das disciplinas a que 
    * o aluno est inscrito.
    */ 
   public ArrayList<String> getDiscp(){
        ArrayList<String> dsp = new ArrayList<String>(discp);
        return dsp;
   } 
   
   /** Verifica se o aluno est inscrito a dada disciplina */
   public boolean inscritoA(String disciplina) {
       return discp.contains(disciplina);
    }
      
    /** Devolve o nmero de disciplinas a que o aluno est inscrito */
    public int numInscricoes() { return discp.size(); }
	
	/** Altera o nome do aluno */   
    public void mudaNome(String name){ nome = name;}
    
    /** Altera a mdia do aluno */   
    public void novaMedia(double classif){ media = classif;}
    
    /**
	 * Inscreve o aluno a mais uma disciplina, caso ainda no esteja
	 * inscrito na mesma (usar inscritoA(novaDiscp) antes de invocar
	 * este mtodo !!).
	 */      
    public void inscreveA(String novaDiscp) { discp.add(novaDiscp); }
    
    /** igualdade de FichaAluno: Numero e Nome iguais */
    public boolean equals(Object o) {
        if(this == o) return true;
        if( (o == null) || (this.getClass() != o.getClass()) ) return false;
        FichaAluno fa = (FichaAluno) o;
        // Igualdade
        return ( this.getNumero().equals(fa.getNumero()) && this.getNome().equals(fa.getNome()) );
    }
    
    /** toString() */
    public String toString() {
        StringBuilder s = new StringBuilder();
        s.append(" --- FICHA DO ALUNO N: ");
        s.append(numero); s.append("\n");
        s.append("NOME : "); s.append(nome); s.append("\n");
        s.append("MEDIA : "); s.append(media); s.append("\n");
        s.append("---------  INSCRITO A -------------------\n");
        for(String nome : discp) s.append(nome + "\n"); 
        return s.toString();
    }
    
    /** Clone */
    public FichaAluno clone() { return new FichaAluno(this); }   
}
	
	