 
/**
 * 
 * TurmaMap = TreeMap(Numero do Aluno(String) -> FichaAluno)
 * 
 * @author F. Mrio Martins
 * @version 1.0 01/2005
 */
import java.util.*;
public class TurmaMap {

    private TreeMap<String, FichaAluno> turma; 
		
	/** Construtor por omisso */	
	public TurmaMap() { 
	    turma = new TreeMap<String, FichaAluno>();
	}
	
	/** Construtor por cpia */
	public TurmaMap(TurmaMap tm) {
	    turma = new TreeMap<String, FichaAluno>();
	    for(FichaAluno fa : tm.daFichas()) 
	       turma.put(fa.getNumero(), fa.clone());
	}
		
	// Mtodos de Instncia
	
	/** Devolve uma cpia dos valores do TreeMap */
	public Set<FichaAluno> daFichas() {
	    HashSet<FichaAluno> lfa = new HashSet<FichaAluno>();
	    for(FichaAluno fa : turma.values()) lfa.add(fa.clone());
	    return lfa;
	}
	  
   /**
	 *  Insere um novo aluno na turma. O mtodo  consistente dado 
	 *  que o nmero de aluno  garantidamente igual ao que consta
	 *  da sua ficha !!
	 */
    public void insereAluno(FichaAluno ficha) {		
		turma.put(ficha.getNumero(), ficha.clone());
    }

    /** Remove o aluno cujo nmero  dado como parmetro */	
	public void removeAluno(String codAluno) { turma.remove(codAluno); }
	
	/** Devolve o nmero actual de alunos da turma */
     public int numAlunos() { return turma.size(); }
	
	/** Determina a maior media da turma */	
	public double maiorNotaTurma() {	    
	double maiorMedia = -1.0;	
	for(FichaAluno ficha : turma.values()) {
	     if( ficha.getMedia() > maiorMedia ) 
	          maiorMedia = ficha.getMedia();
	 }	 
	 return maiorMedia;
    }
    
    /** Devolve um Set com os cdigos dos alunos */
    public TreeSet<String> codigos() {	    
	  TreeSet<String> cods = new TreeSet<String>();	  	
	  for(FichaAluno ficha: turma.values()) 
	     cods.add(ficha.getNumero());
	  return cods;
    }
  
    /** Verifica se existe o aluno cujo cdigo  dado */
	public boolean existeAluno(String numAluno) {
	    return turma.keySet().contains(numAluno);
	}
		   
     /**
	 *  Cria o conjunto com os cdigos dos alunos com nota superior  dada
	 *  como parmetro (ex cdigos dos alunos com nota > 12).
	 */
	public TreeSet<String> alunosNotaSuperior(double notaRef) {	    
	 TreeSet<String> codigos = new TreeSet<String>();
	 for(FichaAluno ficha: turma.values()) {
	      if( ficha.getMedia() > notaRef ) codigos.add(ficha.getNumero()) ;	         
	 }	 
	 return codigos;
   }
   
    /** toString() */
    public String toString() {
        StringBuffer s = new StringBuffer();
        s.append("-----------  TURMA --------------------\n");
        for(FichaAluno ficha : turma.values()) 
	       s.append(ficha.toString());   
	    return s.toString();
    } 
    
    /** clone */
    public TurmaMap clone() { return new TurmaMap(this); }
    
 }




	
	